/**  Using clipboard - needs a recent version - Chrome is OK - 
CLICK A COLOR, = COPY to Clipboard with Cb checked. */

var nColors, mousex, mousey, GG, offset = 25;
var Width = 1260, patchSize = 20, HSV = 0;
var decimalout = 6, decout = 6; // for picker
/// ^ output decimal places for POV lib vectors up to 9 or 10 - colors.js 

/* first char should not be separator for .split();
new Arrray(n), otherwise dont clutter up - use [0,0,0]; */

document.onmousedown = mouseDwn;
document.onmouseup = mouseUp;
//document.onmousemove = mRoll;
//document.onkeydown = keyDwn;

function load() {
  var jg = new jsGraphics("Canvas");
  GG=jg;
  jg.setStroke(1);
  jg.setColor("#999999");
  var dc = document;
  // hidectrl(dc.getElementById("picker"));
  drawpalette();
  dc.getElementById("stat").value = "Welcome to POV Color Picker";
}

function drawpalette() {
  patchSize = 19;
  nColors = 1813;
  GG.setColor("#AAAAAA");
  GG.fillRect(0,0,Width,intr(Width*.62));
  var w = Width, dc = document;
  dc = dc.getElementById("colorname");
  dc.value = " Drawing "+nColors+" Colors";
  var i;

  for (i=0;i < nColors; i++) colorpatch(i,w);

  GG.paint();
  dc.value = " Finished Drawing "+nColors+" Colors";
  showpicker();
  decimalout = 0;
}

function mouseDwn(e) {
  var IE = 0;
  var b = IE? event.button: e.which;
  var shft = IE? event.shiftKey:e.shiftKey;
  if (b == 1) {
    var d;
    if (IE) {  // IE case e.pageX == null
      d= (document.documentElement && 
      document.documentElement.scrollLeft != null) ?
      document.documentElement : document.body;
      mousex= event.clientX + d.scrollLeft;
      mousey= event.clientY + d.scrollTop;
    } 
    else { mousex= e.pageX; mousey= e.pageY; }
    // dont know if it should be screen or page or what.
    // aint broke, dont fix it.
    mousey = mousey - offset;

    var m = Math.floor(Width/patchSize);
    var i = nColors, off = 1;
    var x = (i % m) * patchSize;
    var y = Math.floor(i / m) * patchSize;
    if (mousey > (y+patchSize)) off = 1;
    else if (!pickeropen) off = 0;
    if ((mousex > x) && (mousey > y)) off = 1;
    if (mousex > (patchSize * m)) off = 1;

    if ((!off) && (mousey > 0)) {
      // echo(" ");
      m = whichcolor();
      patchHighLight(m);
      if (HSV) bufferhue(m);
      else buffer(m);
    }
  }
  return true;
}
function mouseUp(e) {
    if (!pickeropen) PickerInUse = 0;
    if (e.ctrlKey) send2picker(1);
    if (e.shiftKey) send2picker(2);
    if (e.altKey) send2picker(3);
}
function buffer(i) {
  var n = clamp(i, 0, nColors-1);
  document.getElementById("colorname").value = color[n];
  if (document.getElementById("clip").checked) clipboard("colorname");
}
function bufferhue(i) {
  var n = clamp(i, 0, nColors-1);
  document.getElementById("colorname").value = colorhue(n);
  if (document.getElementById("clip").checked) clipboard("colorname");
}
function whichcolor() {
  var m = Math.floor(Width/patchSize);
  if (mousex > (patchSize * m)) { echo("off edge"); return 0; }
  if (mousey < 0) { echo("before edge"); return 0; }

  var x = Math.floor(mousex/patchSize);
  var y = Math.floor(mousey/patchSize);
  var i = m * y + x;
  if (i >= nColors) echo("No more colors.");
  return i;
}
function send2picker(wkey) {
  var m = Math.floor(Width/patchSize);
  var x = Math.floor(mousex/patchSize);
  var y = Math.floor(mousey/patchSize);
  var i = m * y + x;
  i = clamp(i, 0, nColors-1);

  if (HSV) { // colorhue(i);
    var z = 320, vv;
    var v = .3 + .12 * i / z;
    var h = 1.0 - ((i % z) / z);
    if (i < 960) vv = roundv(hsv2rgb(h,1,v),6);
    else {
      v = .33 + .12 * (i%960) / z;
      vv = roundv(hsl2rgb(h,1,v),6);
    }
    vv = multv(vv,255);
    vv = RGB2Hex(vv);
  }
  else vv = getpovcolor(i);
  if (wkey == 1) {
    document.getElementById('col1').value = delpnd(vv);
    document.getElementById('col1').style.background = vv;
  }
  if (wkey == 2) {
    document.getElementById('col2').value = delpnd(vv);
    document.getElementById('col2').style.background = vv;
  }
  if (wkey == 3) {
    document.getElementById('col3').value = delpnd(vv);
    document.getElementById('col3').style.background = vv;
  }
  updatestat(vv);
}

/// THUMB NAIL
function colorpatch(i,w) {
  var sz = patchSize, c = getpovcolor(i);
  var m = Math.floor(w/sz);
  var x = (i % m) * sz;
  var y = Math.floor(i / m) * sz;
  GG.setColor(c);
  GG.fillRect(x,y,sz,sz);
}
function getpovcolor(i) {
  var s = color[i], c = "#000000";
  if (s.substr(0,1) == " ") s = s.substr(1);
  var t = s.split(" ");
  if (t[3] == "White*") c = float2hex(t[4]);
  if ((t.length == 5) && (i < 9)) c = float2hex(t[4]);
  else if ((t[3] == "color") && (t[4] == "red")) c = color2hex(t[5],t[7],t[9]);
  else if ((t[3] == "color") && (t[4] == "rgb")) c = arr2hex(t[5],t[6],t[7],i);
  else if (t[3] == "rgb") c = arr2hex(t[4],t[5],t[6],i);
  return c;
}
function patchHighLight(i) {
  var w = Width, sz = patchSize;
  var m = Math.floor(w/sz);
  var x = (i % m) * sz;
  var y = Math.floor(i / m) * sz;
  GG.setColor("#FFFFFF");
  GG.drawRect(x,y,sz,sz);
  GG.paint();
}
function float2hex(a) {
  var b = Math.floor(parseFloat("" + a)*255.0);
  return RGB2Hex([b,b,b]);
}
function color2hex(a,b,c) {
  var c = [Math.floor(parseFloat(a)*255.0),
  Math.floor(parseFloat(b)*255.0),
  Math.floor(parseFloat(c)*255.0)];
  return RGB2Hex(c);
}

function arr2hex(a,b,c,i) {
  var d = a, e = b, f = c;
  if (a.substr(0,1) == "<") d = a.substr(1);
  var ar = [parseFloat(d),parseFloat(e),parseFloat(f)];  
  if (decimalout) {
    ar = roundv(ar,decimalout);
    var s = color[i];
    var t = s.split(" ");
    s = "<"+ar[0]+", "+ar[1]+", "+ar[2]+">;";
    if (t[4] == "rgb") color[i] = _string(t[0],t[1],t[2],t[3],t[4],s);
    if (t[3] == "rgb") color[i] = _string(t[0],t[1],t[2],t[3],s);
  }
  ar = [Math.floor(parseFloat(d)*255.0),
  Math.floor(parseFloat(e)*255.0),
  Math.floor(parseFloat(f)*255.0)];
  return RGB2Hex(ar);
}
function initcolopal(s,v) {
  // hsv sat and value initcolopal(1,.3);
  patchSize = 19; nColors = 1920; HSV = 1;
  var z = 320, sat = s, light = v;
  var i = 0, j = 0, k = 0, rgb;
  while (j < 3) {

    i = 0;
    while (i < z) {
      // sat += 0 / z;
      light += .12 / z;
      rgb = hsv2rgb(1.0 - (i / z), sat, light);
      i++;
      drwpatch(k,Width,rgb); k++;
    }
    j++;
  }
  j = 0;
  sat = 1;
  light = .33;
  while (j < 3) {

    i = 1;
    while (i <= z) {
      // sat += 0 / z;
      light += .12 / z;
      rgb = hsl2rgb(1.0 - (i / z), sat, light);
      drwpatch(k,Width,rgb); k++;
      i++;
      // PROGESS
      //if ((((i / z) * 10) % 2) == 0) e intr((i / z) * 100);
    }
    j++;
  }
  GG.paint();
  document.getElementById("colorname").value = 
  " Finished Drawing "+nColors+" Colors";
  showpicker();
}

function drwpatch(i,w,col) {
  var sz = patchSize, c = RGB2Hex(multv(col,255));
  var m = Math.floor(w/sz);
  var x = (i % m) * sz;
  var y = Math.floor(i / m) * sz;
  GG.setColor(c);
  GG.fillRect(x,y,sz,sz);
}
function colorhue(i) {
  var z = 320;
  var v = .3 + .12 * i / z;
  var h = 1.0 - ((i % z) / z);
  if (i < 960) return "HSV"+i + " = <"+roundv(hsv2rgb(h,1,v),6)+">;"; 
  v = .33 + .12 * (i%960) / z;
  return "HSL"+(i%960) + " = <"+roundv(hsl2rgb(h,1,v),6)+">;";
}
function initpovpal() {
  HSV = 0;
  drawpalette();
}
/// UTIL //////////////////////////
function moveLayer(dcp,x,y) {
  dcp.style.left = x+"px";
  dcp.style.top = y+"px";
}
function rnd(num,deci) {
  with (Math) {
    return round(num*pow(10,deci)) / pow(10,deci);
} }
function _round(num,deci) {
  with (Math) {
    return round(num*pow(10,deci)) / pow(10,deci);
} }
function roundv(v,n) {
  return [rnd(v[0],n),rnd(v[1],n),rnd(v[2],n)];
}
function clampv(v,n,m) {
  var vv = [v[0],v[1],v[2]];
  if (v[0] < n) vv[0] = n;
  if (v[0] > m) vv[0] = m;
  if (v[1] < n) vv[1] = n;
  if (v[1] > m) vv[1] = m;
  if (v[2] < n) vv[2] = n;
  if (v[2] > m) vv[2] = m;
  return vv;
}
function addv(a,b) {
  return [a[0]+b[0],a[1]+b[1],a[2]+b[2]];
}
function divv(a,b) {
  if (!b) echo("divv divide by 0")
  else return [a[0]/b,a[1]/b,a[2]/b];
  return a;
}
function multv(a,b) {
  return [a[0]*b,a[1]*b,a[2]*b];
}
function inrect(px,py,x,y,w,h) {
  if ((px > x) && (px < (x+w))) {
    if ((py > y) && (py < (y+h))) {
      return true;
    }
  }
  return false;
}
function clamp(a,n,m) {
  if (a < n) return n;
  if (a > m) return m;
  return a;
}
function showctrl(dcp) {
  dcp.style.visibility = "visible";
}
function hidectrl(dcp) {
  dcp.style.visibility = "hidden";
}

function echoadd() {
  var dc = document;
  var arg = arguments, i = 0, s = "";
  for (i=0;i<arg.length;i++) s = s + " " + arg[i];
  dc.getElementById("stat").value =
  dc.getElementById("stat").value + s.toString();
}
function echo(s) {
  document.getElementById("stat").value = s.toString();
}
function minimum(a,b) {
  if (a < b) return a;
  if (b < a) return b;
  return a;
}
function _String() {
  var arg = arguments, i = 0, s = "";
  for (i=0;i<arg.length;i++) s = s+" "+arg[i];
  return s;
}
function _string() {
  var arg = arguments, i = 0, s = "";
  for (i=0;i<arg.length;i++) s = s+arg[i]+" ";
  return s;
}
function intr(num) {
  var n = Math.floor(Math.abs(num));
  if (num < 0) n = n * -1;
  return n;
}
/// ////////////jsColor Picker//////////////
var pickeropen = 0;

function showpicker() {
  var e = document.getElementById("picker");
  if (e.style.visibility == "hidden") showctrl(e);
  var m = Math.floor(Width/patchSize);
  var i = nColors;
  var x = (i % m) * patchSize;
  var y = Math.floor(i / m) * patchSize;
  moveLayer(e,x,y+offset);
}
function updatestat(col) {
  var e = document.getElementById("stat");
  var v = Hex2RGB(col), c = "#000000";
  var v2 = roundv(divv(v,255),decout);
  e.value='"'+col+'"'+" <"+v2+"> ["+v+"]";
  e.style.background = col;
  e.style.color = 0.213*v2[0] +0.715*v2[1] +
      0.072 * v2[2] < 0.5 ? '#FFF' : '#000';
}

function coloSet(i) {
 var e = document.getElementById("col"+i);
 updatestat('#'+e.value);
}
var PickerInUse = 0; // which Picker is being used.
function pickerid(i) {
  coloSet(i);
  PickerInUse = i;
}